﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using PhoneApp1.Resources;
using System.Windows.Media;
using System.Globalization;
using System.Resources;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Collections;
using System.Reflection;
using System.Threading;
using System.Diagnostics;
using System.Windows.Controls.Primitives;

namespace PhoneApp1
{

    public class CountryCodeInGroup : List<CountryCode>
    {
        public CountryCodeInGroup(string category)
        {
            Key = category;
        }

        public string Key { get; set; }

        public bool HasItems { get { return Count > 0; } }
    }

    public class CountryCodeByNameID : List<CountryCodeInGroup>
    {

    }

    public partial class MainPage : PhoneApplicationPage
    {
        public MainPage()
        {
            InitializeComponent(); 
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            Thread thrBindData = new Thread(CountyCodeBind);
            thrBindData.Start();
            base.OnNavigatedTo(e);
        }

        public void FindChildOfType(DependencyObject root)
        {

            var queue = new Queue<DependencyObject>();
            queue.Enqueue(root);

            while (queue.Count > 0)
            {
                DependencyObject current = queue.Dequeue();
                for (int i = VisualTreeHelper.GetChildrenCount(current) - 1; 0 <= i; i--)
                {
                    var child = VisualTreeHelper.GetChild(current, i);
                    Debug.WriteLine(current.GetType().ToString() + "的第" + i.ToString() + "个子控件是： " + child.GetType().ToString());
                    if (VisualTreeHelper.GetChildrenCount(child) > 0)
                    {
                        FindChildOfType(child);
                    }
                }
            }

        }

        private void LongListSelector_CCode_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            var a = LongListSelector_CCode.SelectedItem;
            itemo = a;
       
            //FindChildOfType(this.LongListSelector_CCode);
        }

        private void CountyCodeBind()
        {
            CountryCodeByNameID countryCodeByNameID = new CountryCodeByNameID();
            string Groups = "#abcdefghijklmnopqrstuvwxyz";
            CultureInfo ci = CultureInfo.CurrentCulture;
            ResourceManager rm = new ResourceManager("PhoneApp1.Resources.CcodeRead", Assembly.GetExecutingAssembly());
            ResourceSet ResouSet = rm.GetResourceSet(ci, true, true);
            IEnumerable<CountryCode> CountryCodeList = null;

            //从国码资源文件选择出CountryCode类型的集合
            var countryCodeQuery = from DictionaryEntry de in ResouSet
                                   let arr = de.Value.ToString().Split(',')
                                   orderby de.Key
                                   select new CountryCode
                                   {
                                       ID = de.Key.ToString(),
                                       CCode = arr[0],
                                       CName = arr[1],
                                   };
            CountryCodeList = countryCodeQuery;



            //根据字母顺序和从国码资源文件查询出的CountryCode集合组成CountryCodeInGroup类型的集合
            var result = from char c in Groups
                         join CountryCode countryCode in CountryCodeList
                         on c.ToString() equals countryCode.ID.Substring(0, 1).ToLower()
                         into countryCodeList
                         select new { Key = c.ToString(), countryCode = countryCodeList };


            //组成CountryCodeByNameID类型实例
            foreach (var entity in result)
            {
                CountryCodeInGroup group = new CountryCodeInGroup(entity.Key);

                foreach (CountryCode Ccode in entity.countryCode)
                {
                    group.Add(Ccode);
                }
                countryCodeByNameID.Add(group);
            }

            //异步对LongListSelector_CCode赋值
            this.LongListSelector_CCode.Dispatcher.BeginInvoke(
                () =>
                {
                    LongListSelector_CCode.ItemsSource = countryCodeByNameID;       
                }
                );
        }

        private object itemo = null;
        private void btn_Click_1(object sender, RoutedEventArgs e)
        {
            var list = LongListSelector_CCode.ItemsSource;
            CountryCodeInGroup ccg;
            CountryCode cc;
            foreach (var i in list)
            {
                ccg = i as CountryCodeInGroup;
                foreach (var item in ccg)
                {
                    cc = item as CountryCode;
                    if (cc.CCode == "+86")
                    {
                        this.LongListSelector_CCode.ScrollTo(cc);
                    }
                }
            }
        }

        private void LongListSelector_CCode_JumpListOpening_1(object sender, EventArgs e)
        {
            int a = 1;
        }
    }

    public class CountryCode : INotifyPropertyChanged
    {
        //定义一国码列表信息集合
        public static ObservableCollection<CountryCode> CCodeList = new ObservableCollection<CountryCode>();


        #region 国码相关属性标识定义
        public string ID { get; set; }//关键字，唯一标识
        public string CCode { get; set; }//国码
        public string CName { get; set; }//国码对应国家的名字

        //国码显示文本的颜色
        private Brush _ShowColor;
        public Brush ShowColor
        {
            get
            {
                return _ShowColor;
            }
            set
            {
                _ShowColor = value;
                NotifyPropertyChanged("ShowColor");
            }
        }
        #endregion


        //将每个属性的新值通知UI，将数据源和UI关联起来
        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                //info为属性的名字
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

        // 声明一个 PropertyChanged 事件
        public event PropertyChangedEventHandler PropertyChanged;


        /// <summary>
        /// 获取国码列表信息集合
        /// </summary>
        /// <returns></returns>
        public static ObservableCollection<CountryCode> GetCCodeResource()
        {
            try
            {
                //定义一国码列表信息集合
                //ObservableCollection<CountryCode> CCodeList = new ObservableCollection<CountryCode>();
                //国码列表Name值列表集合
                ObservableCollection<string> CcodeKeyList = new ObservableCollection<string>();

                ReadCcode MyReadResx = new ReadCcode();
                //1.首先遍历读出国码资源文件中Key列所有的值
                CcodeKeyList = MyReadResx.ReadResxInfo();
                //2.依据Key值获取对应的Value值
                if (CcodeKeyList != null && CcodeKeyList.Count >= 1)
                {
                    for (int i = 0; i < CcodeKeyList.Count; i++)
                    {
                        if (CcodeKeyList[i] != null && CcodeKeyList[i] != "")
                        {
                            string Str_Value = MyReadResx.GetReturnMsg(CcodeKeyList[i]);
                            string[] Str_CodeName = Str_Value.Split(',');

                            CountryCode MyCode = new CountryCode();
                            MyCode.ID = CcodeKeyList[i];
                            MyCode.CCode = Str_CodeName[0];
                            MyCode.CName = Str_CodeName[1];

                            //字体颜色的特殊处理
                            string Str_CurrentCulture = CultureInfo.CurrentCulture.Name.ToString();
                            string[] Str_CF = Str_CurrentCulture.Split('-');
                            if (CcodeKeyList[i] == Str_CF[1])
                            {
                                MyCode.ShowColor = new SolidColorBrush(Colors.Red);
                            }
                            else
                            {
                                MyCode.ShowColor = new SolidColorBrush(Colors.White);
                            }

                            CCodeList.Add(MyCode);
                        }
                    }
                    if (CCodeList != null && CCodeList.Count >= 1)
                    {
                        return CCodeList;
                    }
                    else
                    {
                        return null;
                    }
                }
                else
                {
                    return null;
                }
            }
            catch //(Exception ex)
            {
                return null;
            }
        }

        public static string GetCCodeIDKey(CountryCode CCode)
        {
            char key = char.ToLower(CCode.ID[0]);

            if (key < 'a' || key > 'z')
            {
                key = '#';
            }

            return key.ToString();
        }

        public static int CompareByCCodeID(object obj1, object obj2)
        {
            CountryCode p1 = (CountryCode)obj1;
            CountryCode p2 = (CountryCode)obj2;

            int result = p1.ID.CompareTo(p2.ID);
            return result;
        }
    }

    public class ReadCcode
    {
        #region 参数定义
        private string Str_CurrentCcode;
        private ResourceManager rm;
        //private string strlanguage;
        public static CultureInfo ci;
        private ObservableCollection<string> CCodeNameList;//存储国码信息列表资源文件集合
        #endregion

        public ReadCcode()
        {
            CCodeNameList = new ObservableCollection<string>();
            ci = CultureInfo.CurrentCulture;
            rm = new ResourceManager("FreePP.Resources.ResourceFiles.Ccode.CcodeRead", Assembly.GetExecutingAssembly());
        }
        /// <summary>
        /// 遍历国码资源文件的Name列为一个列表集合对象
        /// </summary>
        public ObservableCollection<string> ReadResxInfo()
        {
            try
            {
                ResourceSet ResouSet = rm.GetResourceSet(ci, true, true);
                IDictionaryEnumerator Myide = ResouSet.GetEnumerator();
                foreach (DictionaryEntry d in ResouSet)
                {
                    CCodeNameList.Add(d.Key.ToString());
                }
                if (CCodeNameList != null && CCodeNameList.Count >= 1)
                {
                    return CCodeNameList;
                }
                else
                {
                    return null;
                }
            }
            catch
            {
                return null;
            }
        }
        /// <summary>
        /// 获取当前操作系统的国码值
        /// </summary>
        /// <returns></returns>
        public string GetCurrentOsCcode()
        {
            try
            {
                string Str_Ci = ci.Name.ToString();
                string[] Str_CiUse = Str_Ci.Split('-');
                Str_CurrentCcode = GetReturnMsg(Str_CiUse[1]);

                //string[] Str_CodeShow = Str_CurrentCcode.Split(',');
                //Str_CurrentCcode = Str_CodeShow[0] +" "+ Str_CodeShow[1];
                return Str_CurrentCcode;
            }
            catch
            {
                return "";
            }
        }
        /// <summary>
        /// 获取对应Name码的Value值
        /// </summary>
        /// <param name="returncode"></param>
        /// <returns></returns>
        public string GetReturnMsg(string returncode)
        {
            try
            {
                return rm.GetString(returncode, ci);//取国际化信息正常时
            }
            catch
            {
                return returncode; //国际化出错时直接返回Name代码
            }
        }

    }
}